var AddLibPrepKit = function()
{
	var exreg = {};
	var debug = 0;
	
	var kitNameIsValid = false;
	var reagentFileIsValid = false;
	var consumablesInputIsValid = false;
	var jsonConsumables = {};
	
	// Page initialization
	exreg.initPage = function()
	{
		// Step 1
		Events.addEventHandler('step-1', 'wizard-validate', exreg.validateStep1);
		Events.addEventHandler('kitName', 'change', exreg.kitNameOnChange);
		Events.addEventHandler('expirationDate', 'change', exreg.expirationDateOnChange);
		Events.addEventHandler('reagentFile', 'change', exreg.reagentFileOnChange);

		Buttons.addClickHandler('clearReagents', exreg.clearReagents);
		Buttons.addClickHandler('downloadReagentLotNoFile', exreg.downloadReagentLotNoFile);
		
		// Navigation
		Buttons.addClickHandler('gocancel', Wizard.cancelWizard);
		Buttons.addClickHandler('gorestart', Wizard.restartWizard);
		Buttons.addClickHandler('gonext', Wizard.goNextOnClick);
		Buttons.addClickHandler('goregister', Wizard.goRegister);
/*
		Buttons.addClickHandler('gocreate', exreg.createProtocol);
*/
		
		// Final registration
		Events.addEventHandler('wizard', 'wizard-submit', exreg.submit);

		exreg.initializeStep1();
	}

	exreg.initializeStep1 = function()
	{
		var frm = document.forms['meludi'];
		// Reset reagent fields
		exreg.clearReagents();
		// Reset JSON object for consumables
		jsonConsumables = {};

		// Get next kit name
		var url = '../LibPrep.servlet?ID='+App.getSessionId();
		url += '&cmd=GetNextAutoGeneratedKitName';
		url += '&kitNamePrefix=' + 'LP_kit_';
		url += '&numDigitsInName=3';
		Wizard.showLoadingAnimation('Loading next kit name');
		Wizard.asyncJsonRequest(url, exreg.nextKitNameLoaded);
	}

	exreg.nextKitNameLoaded = function(response)
	{
		var frm = document.forms['meludi'];
		frm.kitName.value = response.name;
		
		Wizard.setCurrentStep(1);
		Doc.show('step-1');
		Doc.hide('gonext');
		Doc.show('gocancel');
/*
		Doc.hide('gocreate');
*/
		Doc.show('goregister');

		Wizard.keepSessionAlive();
	}

	exreg.validateStep1 = function(event)
	{
		var frm = document.forms['meludi'];
		// Add library preparation kit data to JSONObject jsonConsumables
		exreg.addConsumablesInput();
		if (!kitNameIsValid || !consumablesInputIsValid)
		{
			event.preventDefault();
		}
	}

	exreg.clearReagents = function()
	{
		var frm = document.forms['meludi'];

		// Clear reagent values

		// General
		frm.kitName.value = null;
		frm.libraryPrepBox1.value = null;
		frm.indexKit.value = null;
		frm.contentSetBox3.value = null;
		frm.oligoPoolA_FPA.value = null;
		frm.oligoPoolB_FPB.value = null;
		frm.oligoHybridizationSequencingReagent3.value = null;
		frm.stringentWash1_SW1.value = null;
		frm.extensionLigationMix3.value = null;
		frm.pcrMasterMix2_PMM2.value = null;
		frm.ub1.value = null;
		frm.tdp.value = null;
		frm.filterplate.value = null;
		// Index 1 Primers Lot Numbers
		frm.indexPrimerA701.value = null;
		frm.indexPrimerA702.value = null;
		frm.indexPrimerA703.value = null;
		frm.indexPrimerA704.value = null;
		frm.indexPrimerA705.value = null;
		frm.indexPrimerA706.value = null;
		frm.indexPrimerA707.value = null;
		frm.indexPrimerA708.value = null;
		frm.indexPrimerA709.value = null;
		frm.indexPrimerA710.value = null;
		frm.indexPrimerA711.value = null;
		frm.indexPrimerA712.value = null;
		// Index 2 Primers Lot Numbers
		frm.indexPrimerA501.value = null;
		frm.indexPrimerA502.value = null;
		frm.indexPrimerA503.value = null;
		frm.indexPrimerA504.value = null;
		frm.indexPrimerA505.value = null;
		frm.indexPrimerA506.value = null;
		frm.indexPrimerA507.value = null;
		frm.indexPrimerA508.value = null;
		// Expiration date
		frm.expirationDate.value = null;

		// Call exreg.kitNameOnChange() to mark blank name as invalid
		exreg.kitNameOnChange();
	}
	
	exreg.addConsumablesInput = function()
	{
		var frm = document.forms['meludi'];
		consumablesInputIsValid = false;

		var jsonHeaders = exreg.createJsonHeader();

		// Column data are stored in JSONArrays
		var jsonKitName = [];
		var jsonLibraryPrepBox1 = [];
		var jsonIndexKit = [];
		var jsonContentSetBox3 = [];
		var jsonOligoPoolA_FPA = [];
		var jsonOligoPoolB_FPB = [];
		var jsonOligoHybridizationSequencingReagent3 = [];
		var jsonStringentWash1_SW1 = [];
		var jsonExtensionLigationMix3 = [];
		var jsonPcrMasterMix2_PMM2 = [];
		var jsonUB1 = [];
		var jsonTDP = [];
		var jsonFilterplate = [];
		
		var jsonIndexPrimerA701 = [];
		var jsonIndexPrimerA702 = [];
		var jsonIndexPrimerA703 = [];
		var jsonIndexPrimerA704 = [];
		var jsonIndexPrimerA705 = [];
		var jsonIndexPrimerA706 = [];
		var jsonIndexPrimerA707 = [];
		var jsonIndexPrimerA708 = [];
		var jsonIndexPrimerA709 = [];
		var jsonIndexPrimerA710 = [];
		var jsonIndexPrimerA711 = [];
		var jsonIndexPrimerA712 = [];
		
		var jsonIndexPrimerA501 = [];
		var jsonIndexPrimerA502 = [];
		var jsonIndexPrimerA503 = [];
		var jsonIndexPrimerA504 = [];
		var jsonIndexPrimerA505 = [];
		var jsonIndexPrimerA506 = [];
		var jsonIndexPrimerA507 = [];
		var jsonIndexPrimerA508 = [];

		var jsonExpirationDate = [];

		var j = 0;
		// General
		jsonKitName[j] = frm.kitName.value;
		jsonLibraryPrepBox1[j] = frm.libraryPrepBox1.value;
		jsonIndexKit[j] = frm.indexKit.value;
		jsonContentSetBox3[j] = frm.contentSetBox3.value;
		jsonOligoPoolA_FPA[j] = frm.oligoPoolA_FPA.value;
		jsonOligoPoolB_FPB[j] = frm.oligoPoolB_FPB.value;
		jsonOligoHybridizationSequencingReagent3[j] = frm.oligoHybridizationSequencingReagent3.value;
		jsonStringentWash1_SW1[j] = frm.stringentWash1_SW1.value;
		jsonExtensionLigationMix3[j] = frm.extensionLigationMix3.value;
		jsonPcrMasterMix2_PMM2[j] = frm.pcrMasterMix2_PMM2.value;
		jsonUB1[j] = frm.ub1.value;
		jsonTDP[j] = frm.tdp.value;
		jsonFilterplate[j] = frm.filterplate.value;
		// Index 1 Primers Lot Numbers
		jsonIndexPrimerA701[j] = frm.indexPrimerA701.value;
		jsonIndexPrimerA702[j] = frm.indexPrimerA702.value;
		jsonIndexPrimerA703[j] = frm.indexPrimerA703.value;
		jsonIndexPrimerA704[j] = frm.indexPrimerA704.value;
		jsonIndexPrimerA705[j] = frm.indexPrimerA705.value;
		jsonIndexPrimerA706[j] = frm.indexPrimerA706.value;
		jsonIndexPrimerA707[j] = frm.indexPrimerA707.value;
		jsonIndexPrimerA708[j] = frm.indexPrimerA708.value;
		jsonIndexPrimerA709[j] = frm.indexPrimerA709.value;
		jsonIndexPrimerA710[j] = frm.indexPrimerA710.value;
		jsonIndexPrimerA711[j] = frm.indexPrimerA711.value;
		jsonIndexPrimerA712[j] = frm.indexPrimerA712.value;
		// Index 2 Primers Lot Numbers
		jsonIndexPrimerA501[j] = frm.indexPrimerA501.value;
		jsonIndexPrimerA502[j] = frm.indexPrimerA502.value;
		jsonIndexPrimerA503[j] = frm.indexPrimerA503.value;
		jsonIndexPrimerA504[j] = frm.indexPrimerA504.value;
		jsonIndexPrimerA505[j] = frm.indexPrimerA505.value;
		jsonIndexPrimerA506[j] = frm.indexPrimerA506.value;
		jsonIndexPrimerA507[j] = frm.indexPrimerA507.value;
		jsonIndexPrimerA508[j] = frm.indexPrimerA508.value;
		// Expiration date
		jsonExpirationDate[j] = frm.expirationDate.value;

		jsonConsumables['Headers'] = jsonHeaders;

		jsonConsumables['KitName'] = jsonKitName;
		jsonConsumables['LibraryPrepBox1'] = jsonLibraryPrepBox1;
		jsonConsumables['IndexKit'] = jsonIndexKit;
		jsonConsumables['ContentSetBox3'] = jsonContentSetBox3;
		jsonConsumables['OligoPoolA_FPA'] = jsonOligoPoolA_FPA;
		jsonConsumables['OligoPoolB_FPB'] = jsonOligoPoolB_FPB;
		jsonConsumables['OligoHybridizationSequencingReagent3'] = jsonOligoHybridizationSequencingReagent3;
		jsonConsumables['StringentWash1_SW1'] = jsonStringentWash1_SW1;
		jsonConsumables['ExtensionLigationMix3'] = jsonExtensionLigationMix3;
		jsonConsumables['PcrMasterMix2_PMM2'] = jsonPcrMasterMix2_PMM2;
		jsonConsumables['UB1'] = jsonUB1;
		jsonConsumables['TDP'] = jsonTDP;
		jsonConsumables['Filterplate'] = jsonFilterplate;

		jsonConsumables['IndexPrimerA701'] = jsonIndexPrimerA701;
		jsonConsumables['IndexPrimerA702'] = jsonIndexPrimerA702;
		jsonConsumables['IndexPrimerA703'] = jsonIndexPrimerA703;
		jsonConsumables['IndexPrimerA704'] = jsonIndexPrimerA704;
		jsonConsumables['IndexPrimerA705'] = jsonIndexPrimerA705;
		jsonConsumables['IndexPrimerA706'] = jsonIndexPrimerA706;
		jsonConsumables['IndexPrimerA707'] = jsonIndexPrimerA707;
		jsonConsumables['IndexPrimerA708'] = jsonIndexPrimerA708;
		jsonConsumables['IndexPrimerA709'] = jsonIndexPrimerA709;
		jsonConsumables['IndexPrimerA710'] = jsonIndexPrimerA710;
		jsonConsumables['IndexPrimerA711'] = jsonIndexPrimerA711;
		jsonConsumables['IndexPrimerA712'] = jsonIndexPrimerA712;

		jsonConsumables['IndexPrimerA501'] = jsonIndexPrimerA501;
		jsonConsumables['IndexPrimerA502'] = jsonIndexPrimerA502;
		jsonConsumables['IndexPrimerA503'] = jsonIndexPrimerA503;
		jsonConsumables['IndexPrimerA504'] = jsonIndexPrimerA504;
		jsonConsumables['IndexPrimerA505'] = jsonIndexPrimerA505;
		jsonConsumables['IndexPrimerA506'] = jsonIndexPrimerA506;
		jsonConsumables['IndexPrimerA507'] = jsonIndexPrimerA507;
		jsonConsumables['IndexPrimerA508'] = jsonIndexPrimerA508;

		jsonConsumables['ExpirationDate'] = jsonExpirationDate;

		//Wizard.setInputStatus('consumablesFile', 'valid');
		consumablesInputIsValid = true;
	}

	exreg.createJsonHeader = function()
	{
		// Column data are stored in JSONArrays
		var jsonHeaders = [];

		// General
		jsonHeaders[jsonHeaders.length] = 'TruSight Tumor Library Preparation partI';
		jsonHeaders[jsonHeaders.length] = 'TruSight Tumor Library Prep Box 1';
		jsonHeaders[jsonHeaders.length] = 'TruSight Tumor Index Kit';
		jsonHeaders[jsonHeaders.length] = 'TruSight Tumor Content Set Box 3';
		jsonHeaders[jsonHeaders.length] = 'TruSight Tumor Oligo Pool A (FPA)';
		jsonHeaders[jsonHeaders.length] = 'TruSight Tumor Oligo Pool B (FPB)';
		jsonHeaders[jsonHeaders.length] = 'Oligo Hybridization for Sequencing Reagent 3 (OHS3)';
		jsonHeaders[jsonHeaders.length] = 'Stringent Wash 1 (SW1)';
		jsonHeaders[jsonHeaders.length] = 'Extension Ligation Mix 3 (ELM3)';
		jsonHeaders[jsonHeaders.length] = 'PCR Master Mix 2 (PMM2)';
		jsonHeaders[jsonHeaders.length] = 'UB1';
		jsonHeaders[jsonHeaders.length] = 'TDP';
		jsonHeaders[jsonHeaders.length] = 'Filterplate';
		// Index 1 Primers Lot Numbers
		jsonHeaders[jsonHeaders.length] = 'Index Primer A701';
		jsonHeaders[jsonHeaders.length] = 'Index Primer A702';
		jsonHeaders[jsonHeaders.length] = 'Index Primer A703';
		jsonHeaders[jsonHeaders.length] = 'Index Primer A704';
		jsonHeaders[jsonHeaders.length] = 'Index Primer A705';
		jsonHeaders[jsonHeaders.length] = 'Index Primer A706';
		jsonHeaders[jsonHeaders.length] = 'Index Primer A707';
		jsonHeaders[jsonHeaders.length] = 'Index Primer A708';
		jsonHeaders[jsonHeaders.length] = 'Index Primer A709';
		jsonHeaders[jsonHeaders.length] = 'Index Primer A710';
		jsonHeaders[jsonHeaders.length] = 'Index Primer A711';
		jsonHeaders[jsonHeaders.length] = 'Index Primer A712';
		// Index 2 Primers Lot Numbers
		jsonHeaders[jsonHeaders.length] = 'Index Primer A501';
		jsonHeaders[jsonHeaders.length] = 'Index Primer A502';
		jsonHeaders[jsonHeaders.length] = 'Index Primer A503';
		jsonHeaders[jsonHeaders.length] = 'Index Primer A504';
		jsonHeaders[jsonHeaders.length] = 'Index Primer A505';
		jsonHeaders[jsonHeaders.length] = 'Index Primer A506';
		jsonHeaders[jsonHeaders.length] = 'Index Primer A507';
		jsonHeaders[jsonHeaders.length] = 'Index Primer A508';
		// Expiration date
		jsonHeaders[jsonHeaders.length] = 'Expiration date';

		return jsonHeaders;
	}

	exreg.kitNameOnChange = function()
	{
		var frm = document.forms['meludi'];
		
		var kitName = frm.kitName.value;
		if (kitName == null || kitName == '')
		{
			kitNameIsValid = false;
			Wizard.setInputStatus('kitName', 'invalid', 'Not a valid name');
			return;
		}

		kitNameIsValid = true;
		Wizard.setInputStatus('kitName', 'valid');
	}

	exreg.expirationDateOnChange = function()
	{
		var frm = document.forms['meludi'];
		
		var expirationDateIsValid = Wizard.isValid('expirationDate');
		
		if (!expirationDateIsValid) return;

		var expirationDate = Dates.parseString(frm.expirationDate.value, 'yyyyMMdd');
		if (expirationDate == null)
		{
			Wizard.setInputStatus('expirationDate', 'invalid', 'Not a valid date');
			return;
		}
		var currentDate = Dates.parseString(exreg.getTodaysDate(), 'yyyyMMdd');
		if (currentDate > expirationDate)
		{
			Wizard.setInputStatus('expirationDate', 'warning', 'Expiration date is already passed!');
			return;
		}

		Wizard.setInputStatus('expirationDate', 'valid');
	}

	exreg.getTodaysDate = function()
	{
		// Get current time stamp
		var now = new Date();
		return exreg.timestampToDateString(now);
	}

	exreg.timestampToDateString = function(timestamp)
	{
		// Get  date in components yyyy, mm, dd
		var yyyy = timestamp.getFullYear();
		var mm = timestamp.getMonth()+1; //January is 0!
		if (mm < 10)
		{
			mm = '0' + mm;
		}
		var dd = timestamp.getDate();
		if (dd < 10)
		{
			dd = '0' + dd;
		}
		var dateString = '' + yyyy + mm + dd;

		return dateString;
	}

	exreg.reagentFileOnChange = function()
	{
		var frm = document.forms['meludi'];
		var file = frm.reagentFile.files[0];
		
		var reader = new FileReader();
		reader.onload = exreg.reagentFileLoaded;
		reader.readAsText(file);
	}

	exreg.reagentFileLoaded = function(event)
	{
		exreg.parseReagentFile(event.target.result);
	}

	exreg.parseReagentFile = function(data)
	{
		var frm = document.forms['meludi'];
		reagentFileIsValid = false;

		var numReagentItems = 0;

		// Reset the column numbers
		var kitNameColumnNo = -1;
		var libraryPrepBox1ColumnNo = -1;
		var indexKitColumnNo = -1;
		var contentSetBox3ColumnNo = -1;
		var oligoPoolA_FPAColumnNo = -1;
		var oligoPoolB_FPBColumnNo = -1;
		var oligoHybridizationSequencingReagent3ColumnNo = -1;
		var stringentWash1_SW1ColumnNo = -1;
		var extensionLigationMix3ColumnNo = -1;
		var pcrMasterMix2_PMM2ColumnNo = -1;
		var ub1ColumnNo = -1;
		var tdpColumnNo = -1;
		var filterplateColumnNo = -1;
		
		var indexPrimerA701ColumnNo = -1;
		var indexPrimerA702ColumnNo = -1;
		var indexPrimerA703ColumnNo = -1;
		var indexPrimerA704ColumnNo = -1;
		var indexPrimerA705ColumnNo = -1;
		var indexPrimerA706ColumnNo = -1;
		var indexPrimerA707ColumnNo = -1;
		var indexPrimerA708ColumnNo = -1;
		var indexPrimerA709ColumnNo = -1;
		var indexPrimerA710ColumnNo = -1;
		var indexPrimerA711ColumnNo = -1;
		var indexPrimerA712ColumnNo = -1;
		
		var indexPrimerA501ColumnNo = -1;
		var indexPrimerA502ColumnNo = -1;
		var indexPrimerA503ColumnNo = -1;
		var indexPrimerA504ColumnNo = -1;
		var indexPrimerA505ColumnNo = -1;
		var indexPrimerA506ColumnNo = -1;
		var indexPrimerA507ColumnNo = -1;
		var indexPrimerA508ColumnNo = -1;

		var expirationDateColumnNo = -1;

		// Reset the existing values
		var kitName = '';
		var libraryPrepBox1 = '';
		var indexKit = '';
		var contentSetBox3 = '';
		var oligoPoolA_FPA = '';
		var oligoPoolB_FPB = '';
		var oligoHybridizationSequencingReagent3 = '';
		var stringentWash1_SW1 = '';
		var extensionLigationMix3 = '';
		var pcrMasterMix2_PMM2 = '';
		var ub1 = '';
		var tdp = '';
		var filterplate = '';
		
		var indexPrimerA701 = '';
		var indexPrimerA702 = '';
		var indexPrimerA703 = '';
		var indexPrimerA704 = '';
		var indexPrimerA705 = '';
		var indexPrimerA706 = '';
		var indexPrimerA707 = '';
		var indexPrimerA708 = '';
		var indexPrimerA709 = '';
		var indexPrimerA710 = '';
		var indexPrimerA711 = '';
		var indexPrimerA712 = '';
		
		var indexPrimerA501 = '';
		var indexPrimerA502 = '';
		var indexPrimerA503 = '';
		var indexPrimerA504 = '';
		var indexPrimerA505 = '';
		var indexPrimerA506 = '';
		var indexPrimerA507 = '';
		var indexPrimerA508 = '';

		var expirationDate = '';

		// Find column separator as first character after first occurrence of search string
		var separator = ExtractUtils.findSeparator(data, "TruSight Tumor Library Preparation partI");
		if (separator == null)
		{
			// Comma is default separator
			separator = ',';
		}
		var columnSplitRegexp = new RegExp(" *" + separator + " *",'');
		var lines = data.split(/[\n\r]+/);
		var columns = lines[0].split(columnSplitRegexp);

		var numImported = 0;
		for (var i = 1; i < lines.length; i++)
		{
			if (lines[i].match(/^\s*$/)) continue; // Ignore empty lines
			var row = lines[i].split(columnSplitRegexp);
			if (row.length > 1) 
			{
				var key = row[0];
				if (!key || key == '') continue; // with the next line

				if (key == 'TruSight Tumor Library Preparation partI')
				{
					// Header line
					for (var j = 0; j < row.length; j++)
					{
						if (row[j] == 'TruSight Tumor Library Preparation partI')
						{
							kitNameColumnNo = j;
						}
						else if (row[j] == 'TruSight Tumor Library Prep Box 1')
						{
							libraryPrepBox1ColumnNo = j;
						}
						else if (row[j] == 'TruSight Tumor Index Kit')
						{
							indexKitColumnNo = j;
						}
						else if (row[j] == 'TruSight Tumor Content Set Box 3')
						{
							contentSetBox3ColumnNo = j;
						}
						else if (row[j] == 'TruSight Tumor Oligo Pool A (FPA)')
						{
							oligoPoolA_FPAColumnNo = j;
						}
						else if (row[j] == 'TruSight Tumor Oligo Pool B (FPB)')
						{
							oligoPoolB_FPBColumnNo = j;
						}
						else if (row[j] == 'Oligo Hybridization for Sequencing Reagent 3 (OHS3)')
						{
							oligoHybridizationSequencingReagent3ColumnNo = j;
						}
						else if (row[j] == 'Stringent Wash 1 (SW1)')
						{
							stringentWash1_SW1ColumnNo = j;
						}
						else if (row[j] == 'Extension Ligation Mix 3 (ELM3)')
						{
							extensionLigationMix3ColumnNo = j;
						}
						else if (row[j] == 'PCR Master Mix 2 (PMM2)')
						{
							pcrMasterMix2_PMM2ColumnNo = j;
						}
						else if (row[j] == 'UB1')
						{
							ub1ColumnNo = j;
						}
						else if (row[j] == 'TDP')
						{
							tdpColumnNo = j;
						}
						else if (row[j] == 'Filterplate')
						{
							filterplateColumnNo = j;
						}
						else if (row[j] == 'A701')
						{
							indexPrimerA701ColumnNo = j;
						}
						else if (row[j] == 'A702')
						{
							indexPrimerA702ColumnNo = j;
						}
						else if (row[j] == 'A703')
						{
							indexPrimerA703ColumnNo = j;
						}
						else if (row[j] == 'A704')
						{
							indexPrimerA704ColumnNo = j;
						}
						else if (row[j] == 'A705')
						{
							indexPrimerA705ColumnNo = j;
						}
						else if (row[j] == 'A706')
						{
							indexPrimerA706ColumnNo = j;
						}
						else if (row[j] == 'A707')
						{
							indexPrimerA707ColumnNo = j;
						}
						else if (row[j] == 'A708')
						{
							indexPrimerA708ColumnNo = j;
						}
						else if (row[j] == 'A709')
						{
							indexPrimerA709ColumnNo = j;
						}
						else if (row[j] == 'A710')
						{
							indexPrimerA710ColumnNo = j;
						}
						else if (row[j] == 'A711')
						{
							indexPrimerA711ColumnNo = j;
						}
						else if (row[j] == 'A712')
						{
							indexPrimerA712ColumnNo = j;
						}
						else if (row[j] == 'A501')
						{
							indexPrimerA501ColumnNo = j;
						}
						else if (row[j] == 'A502')
						{
							indexPrimerA502ColumnNo = j;
						}
						else if (row[j] == 'A503')
						{
							indexPrimerA503ColumnNo = j;
						}
						else if (row[j] == 'A504')
						{
							indexPrimerA504ColumnNo = j;
						}
						else if (row[j] == 'A505')
						{
							indexPrimerA505ColumnNo = j;
						}
						else if (row[j] == 'A506')
						{
							indexPrimerA506ColumnNo = j;
						}
						else if (row[j] == 'A507')
						{
							indexPrimerA507ColumnNo = j;
						}
						else if (row[j] == 'A508')
						{
							indexPrimerA508ColumnNo = j;
						}
						else if (row[j] == 'Expiration date')
						{
							expirationDateColumnNo = j;
						}
					}
				}

				// Check if key starts with "ML_"
				if (key.match(/^ML_.*$/))
				{
					// Library preparation kit line
					if (kitNameColumnNo >= 0)
					{
						kitName = row[kitNameColumnNo];
					}
					if (libraryPrepBox1ColumnNo >= 0)
					{
						libraryPrepBox1 = row[libraryPrepBox1ColumnNo];
					}
					if (indexKitColumnNo >= 0)
					{
						indexKit = row[indexKitColumnNo];
					}
					if (contentSetBox3ColumnNo >= 0)
					{
						contentSetBox3 = row[contentSetBox3ColumnNo];
					}
					if (oligoPoolA_FPAColumnNo >= 0)
					{
						oligoPoolA_FPA = row[oligoPoolA_FPAColumnNo];
					}
					if (oligoPoolB_FPBColumnNo >= 0)
					{
						oligoPoolB_FPB = row[oligoPoolB_FPBColumnNo];
					}
					if (oligoHybridizationSequencingReagent3ColumnNo >= 0)
					{
						oligoHybridizationSequencingReagent3 = row[oligoHybridizationSequencingReagent3ColumnNo];
					}
					if (stringentWash1_SW1ColumnNo >= 0)
					{
						stringentWash1_SW1 = row[stringentWash1_SW1ColumnNo];
					}
					if (extensionLigationMix3ColumnNo >= 0)
					{
						extensionLigationMix3 = row[extensionLigationMix3ColumnNo];
					}
					if (pcrMasterMix2_PMM2ColumnNo >= 0)
					{
						pcrMasterMix2_PMM2 = row[pcrMasterMix2_PMM2ColumnNo];
					}
					if (ub1ColumnNo >= 0)
					{
						ub1 = row[ub1ColumnNo];
					}
					if (tdpColumnNo >= 0)
					{
						tdp = row[tdpColumnNo];
					}
					if (filterplateColumnNo >= 0)
					{
						filterplate = row[filterplateColumnNo];
					}
					if (indexPrimerA701ColumnNo >= 0)
					{
						indexPrimerA701 = row[indexPrimerA701ColumnNo];
					}
					if (indexPrimerA702ColumnNo >= 0)
					{
						indexPrimerA702 = row[indexPrimerA702ColumnNo];
					}
					if (indexPrimerA703ColumnNo >= 0)
					{
						indexPrimerA703 = row[indexPrimerA703ColumnNo];
					}
					if (indexPrimerA704ColumnNo >= 0)
					{
						indexPrimerA704 = row[indexPrimerA704ColumnNo];
					}
					if (indexPrimerA705ColumnNo >= 0)
					{
						indexPrimerA705 = row[indexPrimerA705ColumnNo];
					}
					if (indexPrimerA706ColumnNo >= 0)
					{
						indexPrimerA706 = row[indexPrimerA706ColumnNo];
					}
					if (indexPrimerA707ColumnNo >= 0)
					{
						indexPrimerA707 = row[indexPrimerA707ColumnNo];
					}
					if (indexPrimerA708ColumnNo >= 0)
					{
						indexPrimerA708 = row[indexPrimerA708ColumnNo];
					}
					if (indexPrimerA709ColumnNo >= 0)
					{
						indexPrimerA709 = row[indexPrimerA709ColumnNo];
					}
					if (indexPrimerA710ColumnNo >= 0)
					{
						indexPrimerA710 = row[indexPrimerA710ColumnNo];
					}
					if (indexPrimerA711ColumnNo >= 0)
					{
						indexPrimerA711 = row[indexPrimerA711ColumnNo];
					}
					if (indexPrimerA712ColumnNo >= 0)
					{
						indexPrimerA712 = row[indexPrimerA712ColumnNo];
					}
					if (indexPrimerA501ColumnNo >= 0)
					{
						indexPrimerA501 = row[indexPrimerA501ColumnNo];
					}
					if (indexPrimerA502ColumnNo >= 0)
					{
						indexPrimerA502 = row[indexPrimerA502ColumnNo];
					}
					if (indexPrimerA503ColumnNo >= 0)
					{
						indexPrimerA503 = row[indexPrimerA503ColumnNo];
					}
					if (indexPrimerA504ColumnNo >= 0)
					{
						indexPrimerA504 = row[indexPrimerA504ColumnNo];
					}
					if (indexPrimerA505ColumnNo >= 0)
					{
						indexPrimerA505 = row[indexPrimerA505ColumnNo];
					}
					if (indexPrimerA506ColumnNo >= 0)
					{
						indexPrimerA506 = row[indexPrimerA506ColumnNo];
					}
					if (indexPrimerA507ColumnNo >= 0)
					{
						indexPrimerA507 = row[indexPrimerA507ColumnNo];
					}
					if (indexPrimerA508ColumnNo >= 0)
					{
						indexPrimerA508 = row[indexPrimerA508ColumnNo];
					}
					if (expirationDateColumnNo >= 0)
					{
						expirationDate = row[expirationDateColumnNo];
					}
				}
			}
		}

		// Update presented reagent lot number values

		// General
		frm.kitName.value = kitName;
		frm.libraryPrepBox1.value = libraryPrepBox1;
		frm.indexKit.value = indexKit;
		frm.contentSetBox3.value = contentSetBox3;
		frm.oligoPoolA_FPA.value = oligoPoolA_FPA;
		frm.oligoPoolB_FPB.value = oligoPoolB_FPB;
		frm.oligoHybridizationSequencingReagent3.value = oligoHybridizationSequencingReagent3;
		frm.stringentWash1_SW1.value = stringentWash1_SW1;
		frm.extensionLigationMix3.value = extensionLigationMix3;
		frm.pcrMasterMix2_PMM2.value = pcrMasterMix2_PMM2;
		frm.ub1.value = ub1;
		frm.tdp.value = tdp;
		frm.filterplate.value = filterplate;
		// Index 1 Primers Lot Numbers
		frm.indexPrimerA701.value = indexPrimerA701;
		frm.indexPrimerA702.value = indexPrimerA702;
		frm.indexPrimerA703.value = indexPrimerA703;
		frm.indexPrimerA704.value = indexPrimerA704;
		frm.indexPrimerA705.value = indexPrimerA705;
		frm.indexPrimerA706.value = indexPrimerA706;
		frm.indexPrimerA707.value = indexPrimerA707;
		frm.indexPrimerA708.value = indexPrimerA708;
		frm.indexPrimerA709.value = indexPrimerA709;
		frm.indexPrimerA710.value = indexPrimerA710;
		frm.indexPrimerA711.value = indexPrimerA711;
		frm.indexPrimerA712.value = indexPrimerA712;
		// Index 2 Primers Lot Numbers
		frm.indexPrimerA501.value = indexPrimerA501;
		frm.indexPrimerA502.value = indexPrimerA502;
		frm.indexPrimerA503.value = indexPrimerA503;
		frm.indexPrimerA504.value = indexPrimerA504;
		frm.indexPrimerA505.value = indexPrimerA505;
		frm.indexPrimerA506.value = indexPrimerA506;
		frm.indexPrimerA507.value = indexPrimerA507;
		frm.indexPrimerA508.value = indexPrimerA508;
		// Expiration date
		frm.expirationDate.value = expirationDate;

		if (numImported != numReagentItems)
		{
			Wizard.setInputStatus('reagentFile', 'invalid', 'Could not find values for all ' + numReagentItems + ' samples: ' + numImported);
			return;
		}

		// Call exreg.kitNameOnChange() to update kit name valid flag
		exreg.kitNameOnChange();

		Wizard.setInputStatus('reagentFile', 'valid');
		reagentFileIsValid = true;
	}

/*
	exreg.initializeStep2 = function()
	{
		var frm = document.forms['meludi'];
		var consumablesFileName = frm.consumablesFile.value;
		Doc.element('detailsConsumablesFileName').innerHTML = '<b>Consumables file: ' + consumablesFileName + '</b>';
//alert("exreg.initializeStep2(): Start consumablesFile = " + consumablesFileName);
		var html = '<table id="detailsTable" class="step-form">';

		// First header row
		html += '<thead>';
		html += '<tr>';
		html += '<th>TruSight Tumor Library Preparation partI</th>';
		html += '<th class="dottedleft">TruSight Tumor Library Prep Box 1</th>';
		html += '<th class="dottedleft">TruSight Tumor Index Kit</th>';
		html += '<th class="dottedleft">TruSight Tumor Content Set Box 3</th>';
		html += '<th class="dottedleft">TruSight Tumor Oligo Pool A (FPA)</th>';
		html += '<th class="dottedleft">TruSight Tumor Oligo Pool B (FPB)</th>';
		html += '<th class="dottedleft">Oligo Hybridization for Sequencing Reagent 3 (OHS3)</th>';
		html += '<th class="dottedleft">Stringent Wash 1 (SW1)</th>';
		html += '<th class="dottedleft">Extension Ligation Mix 3 (ELM3)</th>';
		html += '<th class="dottedleft">PCR Master Mix 2 (PMM2)</th>';
		html += '<th class="dottedleft">UB1</th>';
		html += '<th class="dottedleft">TDP</th>';
		html += '<th class="dottedleft">Filterplate</th>';
		html += '<th colspan="12" class="dottedleft">Index 1 Primers Lot Number</th>';
		html += '<th colspan="8" class="dottedleft">Index 2 Primers Lot Number</th>';
		html += '</tr>';
		// Second header row
		html += '<tr>';
		html += '<th></th>';
		html += '<th class="dottedleft"></th>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		// Index 1 Primers Lot Number
		html += '<td class="dottedleft">ATCACGAC</td>';
		html += '<td class="dottedleft">ACAGTGGT</td>';
		html += '<td class="dottedleft">CAGATCCA</td>';
		html += '<td class="dottedleft">ACAAACGG</td>';
		html += '<td class="dottedleft">ACCCAGCA</td>';
		html += '<td class="dottedleft">AACCCCTC</td>';
		html += '<td class="dottedleft">CCCAACCT</td>';
		html += '<td class="dottedleft">CACCACAC</td>';
		html += '<td class="dottedleft">GAAACCCA</td>';
		html += '<td class="dottedleft">TGTGACCA</td>';
		html += '<td class="dottedleft">AGGGTCAA</td>';
		html += '<td class="dottedleft">AGGAGTGG</td>';
		// Index 2 Primers Lot Number
		html += '<td class="dottedleft">TGAACCTT</td>';
		html += '<td class="dottedleft">TGCTAAGT</td>';
		html += '<td class="dottedleft">TGTTCTCT</td>';
		html += '<td class="dottedleft">TAAGACAC</td>';
		html += '<td class="dottedleft">CTAATCGA</td>';
		html += '<td class="dottedleft">CTAGAACA</td>';
		html += '<td class="dottedleft">TAAGTTCC</td>';
		html += '<td class="dottedleft">TAGACCTA</td>';
		html += '</tr>';
		// Third header row
		html += '<tr>';
		html += '<th></th>';
		html += '<th class="dottedleft"></th>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		// Index 1 Primers Lot Number
		html += '<td class="dottedleft">A701</td>';
		html += '<td class="dottedleft">A702</td>';
		html += '<td class="dottedleft">A703</td>';
		html += '<td class="dottedleft">A704</td>';
		html += '<td class="dottedleft">A705</td>';
		html += '<td class="dottedleft">A706</td>';
		html += '<td class="dottedleft">A707</td>';
		html += '<td class="dottedleft">A708</td>';
		html += '<td class="dottedleft">A709</td>';
		html += '<td class="dottedleft">A710</td>';
		html += '<td class="dottedleft">A711</td>';
		html += '<td class="dottedleft">A712</td>';
		// Index 2 Primers Lot Number
		html += '<td class="dottedleft">A501</td>';
		html += '<td class="dottedleft">A502</td>';
		html += '<td class="dottedleft">A503</td>';
		html += '<td class="dottedleft">A504</td>';
		html += '<td class="dottedleft">A505</td>';
		html += '<td class="dottedleft">A506</td>';
		html += '<td class="dottedleft">A507</td>';
		html += '<td class="dottedleft">A508</td>';
		html += '</tr>';
		html += '</thead>';
		html += '<tbody>';

		// Get JSONArrays with data for kits

		var jsonHeaders = jsonConsumables['Headers'];

		var jsonKitName = jsonConsumables['KitName'];
		var jsonLibraryPrepBox1 = jsonConsumables['LibraryPrepBox1'];
		var jsonIndexKit = jsonConsumables['IndexKit'];
		var jsonContentSetBox3 = jsonConsumables['ContentSetBox3'];
		var jsonOligoPoolA_FPA = jsonConsumables['OligoPoolA_FPA'];
		var jsonOligoPoolB_FPB = jsonConsumables['OligoPoolB_FPB'];
		var jsonOligoHybridizationSequencingReagent3 = jsonConsumables['OligoHybridizationSequencingReagent3'];
		var jsonStringentWash1_SW1 = jsonConsumables['StringentWash1_SW1'];
		var jsonExtensionLigationMix3 = jsonConsumables['ExtensionLigationMix3'];
		var jsonPcrMasterMix2_PMM2 = jsonConsumables['PcrMasterMix2_PMM2'];
		var jsonUB1 = jsonConsumables['UB1'];
		var jsonTDP = jsonConsumables['TDP'];
		var jsonFilterplate = jsonConsumables['Filterplate'];
		
		var jsonIndexPrimerA701 = jsonConsumables['IndexPrimerA701'];
		var jsonIndexPrimerA702 = jsonConsumables['IndexPrimerA702'];
		var jsonIndexPrimerA703 = jsonConsumables['IndexPrimerA703'];
		var jsonIndexPrimerA704 = jsonConsumables['IndexPrimerA704'];
		var jsonIndexPrimerA705 = jsonConsumables['IndexPrimerA705'];
		var jsonIndexPrimerA706 = jsonConsumables['IndexPrimerA706'];
		var jsonIndexPrimerA707 = jsonConsumables['IndexPrimerA707'];
		var jsonIndexPrimerA708 = jsonConsumables['IndexPrimerA708'];
		var jsonIndexPrimerA709 = jsonConsumables['IndexPrimerA709'];
		var jsonIndexPrimerA710 = jsonConsumables['IndexPrimerA710'];
		var jsonIndexPrimerA711 = jsonConsumables['IndexPrimerA711'];
		var jsonIndexPrimerA712 = jsonConsumables['IndexPrimerA712'];
		
		var jsonIndexPrimerA501 = jsonConsumables['IndexPrimerA501'];
		var jsonIndexPrimerA502 = jsonConsumables['IndexPrimerA502'];
		var jsonIndexPrimerA503 = jsonConsumables['IndexPrimerA503'];
		var jsonIndexPrimerA504 = jsonConsumables['IndexPrimerA504'];
		var jsonIndexPrimerA505 = jsonConsumables['IndexPrimerA505'];
		var jsonIndexPrimerA506 = jsonConsumables['IndexPrimerA506'];
		var jsonIndexPrimerA507 = jsonConsumables['IndexPrimerA507'];
		var jsonIndexPrimerA508 = jsonConsumables['IndexPrimerA508'];

		var numItems = jsonKitName.length;

		for (var i = 0; i < numItems; i++)
		{
			html += '<tr class="highlight">';
			html += '<th>' + Strings.encodeTags(jsonKitName[i]) + '</th>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonLibraryPrepBox1[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexKit[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonContentSetBox3[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonOligoPoolA_FPA[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonOligoPoolB_FPB[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonOligoHybridizationSequencingReagent3[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonStringentWash1_SW1[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonExtensionLigationMix3[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonPcrMasterMix2_PMM2[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonUB1[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonTDP[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonFilterplate[i]) + '</td>';

			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA701[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA702[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA703[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA704[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA705[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA706[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA707[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA708[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA709[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA710[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA711[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA712[i]) + '</td>';

			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA501[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA502[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA503[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA504[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA505[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA506[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA507[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA508[i]) + '</td>';

			html += '</tr>';
		}
		html += '</tbody>';
		html += '</table>';
		Doc.element('detailsSection').innerHTML = html;

		Wizard.setCurrentStep(2);
		Doc.show('gocancel');
		Doc.show('gocreate');
		Doc.show('goregister');
		
		Wizard.keepSessionAlive();
//alert("exreg.initializeStep2(): End consumablesFile = " + consumablesFileName);
	}
*/

	exreg.downloadReagentLotNoFile = function()
	{
		var frm = document.forms['meludi'];
		// Add library preparation kit data to JSONObject jsonConsumables
		exreg.addConsumablesInput();

		var reagentInfo = {};
		var url = '../LibPrep.servlet?ID='+App.getSessionId();
		url += '&cmd=PrepareDownloadReagentLotNoFile';
		url += '&referenceName='+encodeURIComponent(frm.kitName.value);
		url += '&expirationDate='+encodeURIComponent(frm.expirationDate.value);

		// Reagents
		reagentInfo = jsonConsumables;

		// POST
		Wizard.showLoadingAnimation('Performing registration...');
		Wizard.asyncJsonRequest(url, exreg.downloadReagentLotNoFileResults, 'POST', JSON.stringify(reagentInfo));
	}

	exreg.downloadReagentLotNoFileResults = function(response)
	{
		var tmpFilePath = response;
		var frm = document.forms['meludi'];
		var url = '../LibPrep.servlet?ID='+App.getSessionId();
		url += '&cmd=DownloadReagentLotNoFile';
		url += '&referenceName='+encodeURIComponent(frm.kitName.value);
		url += '&expirationDate='+encodeURIComponent(frm.expirationDate.value);
		url += '&tmpFilePath='+encodeURIComponent(tmpFilePath);
		window.open(url);
	}

	exreg.submit = function()
	{
		var frm = document.forms['meludi'];
		
		var submitInfo = {};
		submitInfo = jsonConsumables;

		// Library preparation reagent file
		submitInfo.referenceName = frm.kitName.value;
		submitInfo.expirationDate = frm.expirationDate.value;

		var url = '../LibPrep.servlet?ID='+App.getSessionId();
		url += '&cmd=RegisterKits';
		Wizard.showLoadingAnimation('Performing registration...');
		Wizard.asyncJsonRequest(url, exreg.submissionResults, 'POST', JSON.stringify(submitInfo));
	}
	
	exreg.submissionResults = function(response)
	{
		Wizard.showFinalMessage(response.messages);
		Doc.show('gorestart');
/*
		Doc.show('gocreate');
*/
	}

	return exreg;
}();

Doc.onLoad(AddLibPrepKit.initPage);

